open Ast
open Types
open Typesys

(* Interpreter directives. *)
type directive =
  VoidDir of string
| StringDir of string * string
| BoolDir of string * bool

(* Different kinds of command that could be entered at the prompt. *)
type cmd =
  Directive of directive
| NsortDecCmd of ntyDec
| DtyDecCmd of rawDtyDec
| RelDecCmd of rawRelDec
| ExprCmd of rawExpr
| LetCmd of rawId * (rawId * rawType) list * rawExpr
| LetRecCmd of rawId * (rawId * rawType) list * rawType * rawExpr

(* Should we stop searching for answers, or carry on? *)
type searchCmd = Stop | CarryOn
