open Machine
open Types
open Constraint

(* The state of the machine consists of a frame,
 * a stack of machine values, a list of environments,
 * a Vardata.t which records the types of generated variables
 * and their substitutions, and a Solver.prob which is the
 * leftover constraints after solving! *)
type state = frame * stack * (environment list) * Vardata.t * prob

(* Run a computation in breadth-first mode. *)
val run_breadth : dtyDec -> (state list) -> (mvalue * Vardata.t * prob * (state list)) option

(* Run a computation in depth-first mode. *)
val run_depth : dtyDec -> (state list) -> (mvalue * Vardata.t * prob * (state list)) option

(* Compute a string representation of a state. *)
val soState : state -> string
