(* Interface for the graphical representation of name-name constraints. *)

(* The type of "solutions" for name-name constraints.
 * Currently not used by the toplevel, but it could be. *)
type solution

(* Given a solution, get the "freshfor" variables of some int.
 * Currently not used by the toplevel, but it could be. *)
val getFreshFors : solution -> int -> int list

(* Given a solution, get the "equal to" variables of some int.
 * Currently not used by the toplevel, but it could be. *)
val getEquals : solution -> int -> int list

(* Check satisfiability of name-name constraints using
 * non-deterministic search. *)
val checkSat : Vardata.t -> Constraint.prob -> bool

(* Enumerate "solutions" (i.e. some representation of the namegraph)
 * to a set of name-name constraints, using non-deterministic search.
 * Currently not used by the toplevel, but it could be. *)
val enumSolns : Vardata.t -> Constraint.prob -> solution list
